//
//  MasterViewController.m
//  TapticaDemoApp
//
//  Created by Nissim Pardo on 9/9/14.
//  Copyright (c) 2014 taptica. All rights reserved.
//

#import "MasterViewController.h"

#import "DetailViewController.h"
#import <TapticaSDK/TapticaSDK.h>

static NSString *defaultID = @"c82a818c-859b-4faa-bfee-4dde683b9ae5";

@interface MasterViewController () <UITextFieldDelegate, TAdViewDelegate>{
    NSMutableArray *_objects;
    UITextField *idTF;
    __weak IBOutlet UIBarButtonItem *rightBarButton;
    NSString *adId;
    TAdView *interstitialAD;
}
@end

@implementation MasterViewController

- (void)awakeFromNib
{
    [super awakeFromNib];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    _objects = [[NSMutableArray alloc] initWithArray:@[@"Restore Default ID",
                                                       @"",
                                                       @"Banner AD",
                                                       @"Interstital AD",
                                                       @"Video AD"]];
    adId = defaultID;
}
- (IBAction)saveIdPressed:(UIBarButtonItem *)sender {
    adId = idTF.text;
}


#pragma mark Interstitial methods
- (void)showInterstitialAd:(NSInteger)adType {
    
    // Init interstitial ad
    interstitialAD = [[TAdView alloc] initInterstitial:self];
    interstitialAD.useInternalBrowser = YES;
    interstitialAD.applicationId = adId;
    interstitialAD.adType = adType;
    [interstitialAD update];
}


#pragma mark Ad delegate
// Call the interstitial when the ad is ready
- (void)didReceiveAd:(TAdView *)adView {
    [adView showInterstitial];
}

- (void)TAdView:(TAdView *)adView didFailToReceiveAdWithError:(NSError *)error {
    
}

// Close the ad when the user will click on the close button
- (void)closeButtonPressed:(TAdView *)adView {
    [adView closeInterstitial];
}



- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table View

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _objects.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"Cell" forIndexPath:indexPath];
    
    cell.textLabel.text = _objects[indexPath.row];
    
    
    return cell;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
    UIView *header = [[UIView alloc] initWithFrame:(CGRect){0, 0, 320, 50}];
    idTF = [[UITextField alloc] initWithFrame:(CGRect){0, 0, 292, 30}];
    idTF.delegate = self;
    idTF.center = header.center;
    idTF.placeholder = defaultID;
    idTF.font = [UIFont boldSystemFontOfSize:12];
    idTF.textAlignment = NSTextAlignmentCenter;
    [header addSubview:idTF];
    return header;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if (!indexPath.row) {
        idTF.text = defaultID;
        [idTF resignFirstResponder];
    } else if (indexPath.row == 2) {
        [self performSegueWithIdentifier:@"Banner" sender:@(2)];
    } else if (indexPath.row == 3) {
        [self showInterstitialAd:3];
    } else if (indexPath.row == 4) {
        [self performSegueWithIdentifier:@"Banner" sender:@(5)];
    }
}


- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(NSNumber *)sender
{
    if ([[segue identifier] isEqualToString:@"Banner"]) {
        [[segue destinationViewController] setAdID:adId];
        [segue.destinationViewController setAdType:sender.integerValue];
    }
}


- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    if (textField.text.length == defaultID.length - 1) {
        rightBarButton.enabled = YES;
    }
    return YES;
}
@end
